Bio::DB::Universal(3)

NAME
Bio::DB::Universal - Artificial database that delegates to specific databases

SYNOPSIS
    $uni = Bio::DB::Universal->new();

    # by default connects to web databases. We can also
    # substitute local databases

    $embl = Bio::Index::EMBL->new( -filename => '/some/index/filename/locally/stored');
    $uni->use_database('embl',$embl);

    # treat it like a normal database. Recognises strings
    # like gb|XXXXXX and embl:YYYYYY

    $seq1 = $uni->get_Seq_by_id("embl:HSHNRNPA");
    $seq2 = $uni->get_Seq_by_acc("gb|A000012");

    # with no separator, tries to guess database. In this case the
    # _ is considered to be indicative of swissprot
    $seq3 = $uni->get_Seq_by_id('ROA1_HUMAN');

DESCRIPTION
Artificial database that delegates to specific databases, with a "smart" (well, smartish) guessing routine for what the ids. No doubt the smart routine can be made smarter.

The hope is that you can make this database and just throw ids at it - for most easy cases it will sort you out. Personally, I would be making sure I knew where each id came from and putting it into its own database first - but this is a quick and dirty solution.

By default this connects to web orientated databases, with all the reliability and network bandwidth costs this implies. However you can subsistute your own local databases - they could be Bio::Index databases (DBM file and flat file) or bioperl-db based (MySQL based) or biocorba-based (whatever you like behind the corba interface).

Internally the tags for the databases are

   genbank - ncbi dna database
   embl    - ebi's dna database (these two share accession number space)
   swiss   - swissprot + sptrembl (EBI's protein database)

We should extend this for RefSeq and other sequence databases which are out there... ;)

Inspired by Lincoln Stein, written by Ewan Birney.

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to one of the Bioperl mailing lists. Your participation is much appreciated.

  bioperl-l@bio.perl.org

  Support
Please direct usage questions or support issues to the mailing list:

bioperl-l@bioperl.org

rather than to the module maintainer directly. Many experienced and reponsive experts will be able look at the problem and quickly address it. Please include a thorough description of the problem with code and data examples if at all possible.

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track the bugs and their resolution. Bug reports can be submitted via the web:

  http://bugzilla.open-bio.org/

AUTHOR - Ewan Birney
Email birney@ebi.ac.uk

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  get_Seq_by_id
 Title   : get_Seq_by_id
 Usage   :
 Function:
 Example :
 Returns :
 Args    :

  get_Seq_by_acc
 Title   : get_Seq_by_acc
 Usage   :
 Function:
 Example :
 Returns :
 Args    :

  guess_id
 Title   : guess_id
 Usage   :
 Function:
 Example :
 Returns :
 Args    :

  use_database
 Title   : use_database
 Usage   :
 Function:
 Example :
 Returns :
 Args    :